/*
 * Copyright (C) 2010 Guillaume Quintin.
 * This file is part of cct.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

int cct_init_term(terminal *t,int fd) {
  struct winsize size;
  if ( tcgetattr(fd,&(t->old_termios)) == -1 ) return -1;
  if ( ioctl(fd,CCT_GET_SIZE,&size) == -1 ) return -1;
  t->fd = fd;
  t->w = size.ws_col;
  t->h = size.ws_row;
  t->max = t->w * t->h;
  t->unknown = '#';
  t->ptr = malloc(t->max * (sizeof(char) + sizeof(short)));
  if ( !t->ptr ) return -1;
  t->C = t->ptr;
  t->A = (short*)(t->C + t->max);
  return 0;
}

int cct_end_term(terminal *t) {
  if ( tcsetattr(t->fd,TCSANOW,&t->old_termios) == -1 ) return -1;
  if ( t->ptr ) free(t->ptr);
  return 0;
}

int cct_resize(terminal *t) {
  struct winsize size;
  if ( ioctl(t->fd,CCT_GET_SIZE,&size) == -1 ) return -1;
  t->w = size.ws_col;
  t->h = size.ws_row;
  t->max = t->w * t->h;
  t->ptr = realloc(t->ptr,2 * t->max + 2 * t->max * sizeof(short));
  if ( !t->ptr ) return -1;
  t->C = t->ptr;
  t->A = (short*)(t->C + t->max);
  return 0;
}

