/*
 * Copyright (C) 2010 Guillaume Quintin.
 * This file is part of caca.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

int cct_attr_on(terminal *t,int mode) {
  struct termios term;
  if ( tcgetattr(t->fd,&term) == -1 ) return -1;
  term.c_lflag |= mode;
  if ( tcsetattr(t->fd,TCSANOW,&term) == -1 ) return -1;
  return 0;
}

int cct_icanon_on(terminal *t) {
  return cct_attr_on(t,ICANON);
}

int cct_echo_on(terminal *t) {
  return cct_attr_on(t,ECHO);
}

int cct_attr_off(terminal *t,int mode) {
  struct termios term;
  if ( tcgetattr(t->fd,&term) == -1 ) return -1;
  term.c_lflag &= ~mode;
  if ( tcsetattr(t->fd,TCSANOW,&term) == -1 ) return -1;
  return 0;
}

int cct_icanon_off(terminal *t) {
  return cct_attr_off(t,ICANON);
}

int cct_echo_off(terminal *t) {
  return cct_attr_off(t,ECHO);
}

